/*
 * File: Combinations.js
 * ---------------------
 * This file exports an implementation of the mathematical combinations
 * function C(n, k), which is the number of ways of selecting k objects
 * from a set of n distinct objects.
 */

/*
 * Returns the mathematical combinations function C(n, k), which is
 * the number of ways one can choose k elements from a set of size n.
 */

function combinations(n, k) {
   return fact(n) / (fact(k) * fact(n - k));
}

/*
 * Returns the factorial of n, which is the product of all the
 * integers between 1 and n, inclusive.
 */

function fact(n) {
   let result = 1;
   for (let i = 1; i <= n; i++) {
      result *= i;
   }
   return result;
}
